100 REMark Messages animator for CueDark
110 REMark $$asmb=flp1_djtoolkit_bin,0,12
120 REMark $$asmb=flp1_messages_cfg,0,12
130 :
140 IF SCREEN_MODE <> 8 : MODE 8
150 passed$ = CMD$
160 :
170 DIM text$(9,40)
180 sound% = C_CODE(1)
190 FOR a = 0 TO 9
200   text$(a) = C_STRG$(a+1)
210 END FOR a
220 :
230 IF passed$ > '' THEN
240   xpixels = HEX(passed$(1 TO 4))
250   ypixels = HEX(passed$(5 TO 8))
260   path$ = passed$(10 TO LEN(passed$))
270 ELSE
280   xpixels = 512 : ypixels = 256 : path$ = DATAD$
290 END IF
300 :
310 OPEN #3,'SCR' : WINDOW #3,xpixels,ypixels,0,0
320 :
330 speed% = RND(0 TO 2) : REMark pauses between printing lines of text
340 :
350 REPeat program
360   paper_col% = RND(0 TO 7)
370   REPeat loop
380     ink_col% = RND(0 TO 7)
390     IF ink_col% <> paper_col% THEN EXIT loop
400   END REPeat loop
410   PAPER #3,paper_col% : CLS #3
420   INK #3,ink_col%
430   ht% = RND(0 TO 1) : REMark single or double height
440   CSIZE #3,2,ht%
450   IF ht% = 0 THEN
460     ylim% = ypixels-10 : REMark max. y co-ordinates
470   ELSE
480     ylim% = ypixels-20
490   END IF
500   message_no% = RND(0 TO 9)
510   t$ = text$(message_no%)
520   y% = RND(0 TO ylim%)
530   x% = 0
540   CURSOR #3,x%,y%
550   IF text$(message_no%) = 'DATE' THEN
560     t$ = DATE$ : PRINT #3,t$; : tlen% = 20
570   ELSE
580     PRINT #3,t$; : tlen% = LEN(t$)
590   END IF
600   IF speed% > 0 THEN PAUSE speed%
610   IF RND(0 TO 1) = 0 THEN ydir% = 1 : ELSE ydir% = -1 : END IF
620   xdir% = 2
630   REPeat this_run
640     xlim% = xpixels-(12*tlen%)
650     oldx% = x% : oldy% = y%
660     REMark update co-ordinates
670     x% = x% + xdir% : y% = y% + ydir%
680     changed% = 0 : REMark so that colours can change
690     IF x% < 0 THEN
700       changed% = 1 : x% = 0 : xdir% = - xdir%
710     END IF
720     IF x% > xlim% THEN
730       changed% = 1 : x% = xlim% : xdir% = - xdir%
740     END IF
750     IF y% < 0 THEN
760       changed% = 1 : y% = 0 : ydir% = - ydir%
770     END IF
780     IF y% > ylim% THEN
790       changed% = 1 : y% = ylim% : ydir% = - ydir%
800     END IF
810     :
820     IF changed% THEN
830       REMark excuse to change ink colour?
840       IF RND(1 TO 4) = 4 THEN
850         REPeat loop
860           loop = RND(0 TO 7)
870           IF loop <> ink_col% AND loop <> paper_col% THEN
880             ink_col% = loop : INK #3,ink_col% : EXIT loop
890           END IF
900         END REPeat loop
910       END IF
920     END IF
930     REMark erase right and bottom edges if likely to leave trail
940     REMark which is not overwritten by itself. Character spacing
950     REMark takes care of this at top and left edges
960     IF xdir% < 0 THEN
970       BLOCK #3,2,10*(ht%+1),oldx%+(12*tlen%)-2,oldy%,paper_col%
980     END IF
990     IF ydir% < 0 THEN
1000       BLOCK #3,12*tlen%,1,oldx%,oldy%+(10*(ht%+1))-1,paper_col%
1010     END IF
1020     REMark CURSOR #3,oldx%,oldy% : PRINT #3,t$; : REMark erase old position
1030     IF text$(message_no%) = 'DATE' : t$ = DATE$
1040     CURSOR #3,x%,y%       : PRINT #3,t$; : REMark at new position
1050     IF speed% > 0 THEN PAUSE speed%
1060     :
1070     REMark random chance of finishing
1080     IF RND(1 TO 10000) = 1 THEN
1090       IF sound% : BEEP 500,RND(0 TO 50)
1100       EXIT this_run
1110     END IF
1120     IF RND(1 TO 1000) = 1000 THEN speed% = RND(0 TO 2)
1130   END REPeat this_run
1140 END REPeat program
