100 REMark POLYGONS screen saver module for CueDark
110 REMark written by Dilwyn Jones, 1999
120 :
130 passed$ = CMD$
140 IF passed$ > '' THEN
150   xsize = HEX(passed$(1 TO 4))
160   ysize = HEX(passed$(5 TO 8))
170   path$ = passed$(10 TO LEN(passed$))
180 ELSE
190   IF VER$ = 'HBA' THEN
200     xsize = SCR_XLIM
210     ysize = SCR_YLIM
220   ELSE
230     xsize = 512 : ysize = 256
240   END IF
250   path$ = DATAD$
260 END IF
270 :
280 max_objects = 12 : REMark max. number of polygons on screen
290 max_nodes   =  6 : REMark max. number of corners per polygon
300 :
310 MODE 8 : OPEN #3,'scr'
320 WINDOW #3,xsize,ysize,0,0 : PAPER #3,0 : CLS #3
330 :
340 REPeat program
350   IF RND(1 TO 2) = 2 THEN
360     STRAIGHT_POLYGONS
370   ELSE
380     ARCED_POLYGONS
390   END IF
400   :
410   PAUSE RND(50 TO 200)
420   :
430 END REPeat program
440 :
450 DEFine PROCedure STRAIGHT_POLYGONS
460   objects = RND(3 TO max_objects)
470   nodes   = RND(3 TO max_nodes)
480   DIM px(objects-1,nodes-1),py(objects-1,nodes-1) : REMark corners
490   DIM dx(nodes-1),dy(nodes-1)                     : REMark offsets
500   :
510   REMark set movement relative values for all corners
520   FOR a = 0 TO nodes-1
530     dx(a) = 2*RND(-2 TO 2)
540     dy(a) = 2*RND(-2 TO 2)
550   END FOR a
560   :
570   REMark set start co-ordinates for all corners
580   FOR c = 0 TO nodes-1
590     px(0,c) = RND(1 TO 150)
600     py(0,c) = RND(0 TO 100)
610   END FOR c
620   :
630   FOR a = 1 TO objects-1
640     FOR c = 0 TO nodes-1
650       px(a,c) = px(a-1,c) + dx(c)
660       py(a,c) = py(a-1,c) + dy(c)
670     END FOR c
680   END FOR a
690   :
700   INK #3,7 : PAPER #3,0 : CLS #3
710   colour_no = 1
720   FOR a = 0 TO objects-1
730     PRINT_POLYGON a,colour_no
740     colour_no = colour_no + 1
750     IF colour_no > 7 THEN colour_no = 1
760   END FOR a
770   :
780   REPeat this_run
790     PRINT_POLYGON 0,0 : REMark erase first polygon
800     :
810     REMark shuffle list up to add new polygon at end of list
820     FOR a = 0 TO objects-2
830       FOR c = 0 TO nodes-1
840         px(a,c) = px(a+1,c)
850         py(a,c) = py(a+1,c)
860       END FOR c
870     END FOR a
880     :
890     REMark set new values for objects at end of list
900     FOR c = 0 TO nodes-1
910       px(objects-1,c) = px(objects-1,c) + dx(c)
920       IF px(objects-1,c) <= 0 THEN dx(c) = RND(0 TO 2)
930       IF px(objects-1,c) >= 150 THEN dx(c) = RND(-2 TO 0)
940       :
950       py(objects-1,c) = py(objects-1,c) + dy(c)
960       IF py(objects-1,c) <= 0 THEN dy(c) = RND(0 TO 2)
970       IF py(objects-1,c) >= 100 THEN dy(c) = RND(-2 TO 0)
980     END FOR c
990     INK #3,RND(1 TO 7)
1000     PRINT_POLYGON objects-1,colour_no : REMark draw next shape
1010     colour_no = colour_no + 1
1020     IF colour_no > 7 THEN colour_no = 1
1030     :
1040     IF RND(1 TO 1000) = 1 THEN EXIT this_run
1050     :
1060   END REPeat this_run
1070   :
1080   REMark erase objects slowly
1090   FOR a = 0 TO objects-1 : PRINT_POLYGON a,0 : PAUSE 10
1100   :
1110 END DEFine STRAIGHT_POLYGONS
1120 :
1130 DEFine PROCedure PRINT_POLYGON (no,colour)
1140   LOCal a
1150   INK #3,colour : LINE #3,px(no,0),py(no,0)
1160   FOR a = 1 TO nodes-1 : LINE #3 TO px(no,a),py(no,a)
1170   LINE #3 TO px(no,0),py(no,0) : INK #3,7
1180 END DEFine PRINT_POLYGON
1190 :
1200 DEFine PROCedure ARCED_POLYGONS
1210   objects = RND(3 TO max_objects)
1220   nodes   = RND(3 TO max_nodes)
1230   DIM px(objects-1,nodes-1),py(objects-1,nodes-1) : REMark corner co-ordinates
1240   DIM dx(nodes-1),dy(nodes-1)     : REMark movement offset values
1250   DIM curve(objects-1,nodes-1)
1260   :
1270   REMark set movement relative values for all corners
1280   FOR a = 0 TO nodes-1
1290     dx(a) = RND(-2 TO 2)
1300     dy(a) = 2*RND(-2 TO 2)
1310   END FOR a
1320   :
1330   REMark set start co-ordinates for all corners
1340   FOR c = 0 TO nodes-1
1350     px(0,c) = RND(1 TO 150)
1360     py(0,c) = RND(0 TO 100)
1370     curve(0,c) = RND(-3 TO 3)
1380   END FOR c
1390   :
1400   FOR a = 1 TO objects-1
1410     FOR c = 0 TO nodes-1
1420       px(a,c) = px(a-1,c) + dx(c)
1430       py(a,c) = py(a-1,c) + dy(c)
1440       curve(a,c) = curve(a-1,c)
1450     END FOR c
1460   END FOR a
1470   :
1480   INK #3,7 : PAPER #3,0 : CLS #3
1490   colour_no = 1
1500   FOR a = 0 TO objects-1
1510     PRINT_POLYGON_ARCS a,colour_no : REMark number,colour
1520     colour_no = colour_no + 1
1530     IF colour_no > 7 THEN colour_no = 1
1540   END FOR a
1550   :
1560   REPeat this_run
1570     PRINT_POLYGON_ARCS 0,0 : REMark erase first polygon
1580     :
1590     REMark shuffle list up to add new polygon at end of list
1600     FOR a = 0 TO objects-2
1610       FOR c = 0 TO nodes-1
1620         px(a,c) = px(a+1,c)
1630         py(a,c) = py(a+1,c)
1640         curve(a,c) = curve(a+1,c)
1650       END FOR c
1660     END FOR a
1670     :
1680     REMark set new value for object at end of list
1690     FOR c = 0 TO nodes-1
1700       px(objects-1,c) = px(objects-1,c) + dx(c)
1710       IF px(objects-1,c) <= 0 THEN dx(c) = RND(0 TO 2) : curve(objects-1,c) = RND(-3 TO 3)
1720       IF px(objects-1,c) >= 150 THEN dx(c) = RND(-2 TO 0) : curve(objects-1,c) = RND(-3 TO 3)
1730       :
1740       py(objects-1,c) = py(objects-1,c) + dy(c)
1750       IF py(objects-1,c) <= 0 THEN dy(c) = RND(0 TO 2) : curve(objects-1,c) = RND(-3 TO 3)
1760       IF py(objects-1,c) >= 100 THEN dy(c) = RND(-2 TO 0) : curve(objects-1,c) = RND(-3 TO 3)
1770     END FOR c
1780     :
1790     INK #3,RND(1 TO 7)
1800     PRINT_POLYGON_ARCS objects-1,colour_no : REMark draw next shape
1810     colour_no = colour_no + 1
1820     IF colour_no > 7 THEN colour_no = 1
1830     :
1840     IF RND(1 TO 1000) = 1 THEN EXIT this_run
1850     :
1860   END REPeat this_run
1870   :
1880   REMark slowly erase objects on screen
1890   FOR a = 0 TO objects-1 : PRINT_POLYGON_ARCS a,0 : PAUSE 10
1900   :
1910 END DEFine ARCED_POLYGONS
1920 :
1930 DEFine PROCedure PRINT_POLYGON_ARCS (no,colour)
1940   LOCal a
1950   INK #3,colour : LINE #3,px(no,0),py(no,0)
1960   FOR a = 1 TO nodes-1 : ARC #3 TO px(no,a),py(no,a);curve(no,a)
1970   ARC #3 TO px(no,0),py(no,0);curve(no,a) : INK #3,7
1980 END DEFine PRINT_POLYGON_ARCS
