100 REMark StarsPassing module for CueDark, by Dilwyn Jones
110 :
120 passed$ = CMD$
130 IF passed$ > '' THEN
140   xpixels = HEX(passed$(1 TO 4)) : ypixels = HEX(passed$(5 TO 8))
150   path$ = passed$(10 TO LEN(passed$))
160 ELSE
170   path$ = DATAD$
180   IF VER$ = 'HBA' THEN
190     REMark use SBASIC extensions to determine screen size
200     xpixels = SCR_XLIM : ypixels = SCR_YLIM
210   ELSE
220     REMark give uup trying to determine screen size
230     xpixels = 512 : ypixels = 256
240   END IF
250 END IF
260 xsize% = xpixels
270 ysize% = ypixels
280 :
290 OPEN #3,'scr'
300 WINDOW #3,xsize%,ysize%,0,0 : PAPER #3,0 : INK #3,7 : CLS #3
310 :
320 REMark set number of stars, here proportional to screen width
330 nstars% = xsize% DIV 4 : REMark number of stars
340 :
350 DIM sx%(nstars%-1) : REMark x co-ords of stars
360 DIM sy%(nstars%-1) : REMark y co-ords of stars
370 DIM ss%(nstars%-1) : REMark star speed (pixels shifted at a time)
380 DIM sc%(nstars%-1) : REMark star colours
390 DIM sz%(nstars%-1) : REMark star size
400 :
410 REMark use OVER -1 to overdraw stars
420 OVER #3,-1
430 :
440 REMark set and draw first screenful of stars
450 FOR a = 0 TO nstars% - 1
460   sx%(a) = 4*a : sy%(a) = RND(0 TO ysize%-2)
470   ss%(a) = 2*RND(1 TO 4) : REMark speed of movement
480   sz%(a) = 1 : REMark star size, near ones can be larger
490   IF ss%(a) = 8 THEN
500     IF RND(1 TO 4) = 1 THEN sz%(a) = 2
510   END IF
520   sc%(a) = 7 : REMark normally white
530   IF RND(1 TO 5) = 1 THEN sc%(a) = RND(1 TO 7)
540   BLOCK #3,2,sz%(a),sx%(a),sy%(a),sc%(a)
550 END FOR a
560 :
570 REPeat program
580   REMark update each screenful of stars
590   FOR a = 0 TO nstars%-1
600     :
610     REMark erase star's current position
620     BLOCK #3,2,sz%(a),sx%(a),sy%(a),sc%(a)
630     :
640     REMark calculate next position leftward
650     sx%(a) = sx%(a) - ss%(a)
660     IF sx%(a) < 0 THEN
670       REMark off left of screen, restart right of screen
680       sx%(a) = xsize%-2
690       sy%(a) = RND(0 TO ysize%-2)
700       ss%(a) = 2*RND(1 TO 4) : REMark star speed (how near)
710       :
720       sz%(a) = 1 : REMark each star normally 1 pixel high
730       REMark but fastest (nearest) stars have 25% chance to be larger
740       IF ss%(a) = 8 THEN
750         IF RND(1 TO 4) = 1 THEN sz%(a) = 2
760       END IF
770       sc%(a) = 7 : REMark normally white star
780       REMark but 20% chance of being another colour!
790       IF RND(1 TO 5) = 1 THEN sc%(a) = RND(1 TO 7)
800     END IF
810     :
820     REMark print star at new position
830     BLOCK #3,2,sz%(a),sx%(a),sy%(a),sc%(a)
840   END FOR a
850 END REPeat program
860 STOP
