100 REMark analogue clock
110 REMark $$asmb=flp1_qlib_ext,0,12
120 REMark $$asmb=FLP1_DJTOOLKIT_BIN,0,12
130 REMark $$asmb=FLP1_ANA_CLOCK_cfg,0,12
140 :
150 passed$ = CMD$
160 IF passed$ > '' THEN
170   xpixels = HEX(passed$(1 TO 4))
180   ypixels = HEX(passed$(5 TO 8))
190   path$ = passed$(10 TO LEN(passed$))
200 ELSE
210   xpixels = 512 : ypixels = 256 : path$ = DATAD$
220 END IF
230 :
240 IF SCREEN_MODE <> 8 : MODE 8
250 :
260 REMark need to use #1 because of CURSOR 5 parameters bug
270 REMark so that I can omit the channel number
280 IF Q_MYJOB > 0 : OPEN #1,'scr'
290 :
300 ticks = C_CODE(1) : REMark ticking can be on or off
310 :
320 WINDOW xpixels,ypixels,0,0
330 :
340 REPeat program
350   REMark set colours for this clock
360   CSIZE 2,0
370   paper_col = RND(0 TO 255)
380   REPeat loop2
390     dig_col = RND(0 TO 7)
400     IF dig_col <> paper_col : EXIT loop2
410   END REPeat loop2
420   REPeat loop2
430     hand_col = RND(0 TO 7)
440     REMark hands are drawn using OVER -1, so beware of colours
450     IF (hand_col^^paper_col)<>paper_col THEN EXIT loop2
460   END REPeat loop2
470   REPeat loop2
480     marks_col = RND(0 TO 7)
490     IF marks_col <> paper_col THEN EXIT loop2
500   END REPeat loop2
510   REPeat loop2
520     face_col = RND(0 TO 7)
530     IF face_col <> dig_col AND face_col <> marks_col THEN
540       IF (hand_col^^face_col) <> face_col THEN EXIT loop2
550     END IF
560   END REPeat loop2
570   CLOCK_FACE
580   REMark length of arms
590   xharm =  80*xradius/100 : yharm =  80*yradius/100
600   xmarm = 110*xradius/100 : ymarm = 110*yradius/100
610   xsarm = 136*xradius/100 : ysarm = 136*yradius/100
620   REPeat loop
630     REMark aim to redraw display once every three minutes at random
640     IF RND(1 TO 180) = 1 : EXIT loop
650     REMark show the time
660     time = DATE
670     t$ = DATE$(time)
680     hrs = t$(13 TO 14)
690     mns = t$(16 TO 17)
700     scs = t$(19 TO 20)
710     IF ticks = 1 THEN
720       IF (scs MOD 2) = 1 THEN
730         BEEP 50,20
740       ELSE
750         BEEP 200,70
760       END IF
770     END IF
780     OVER -1
790     INK hand_col
800     REMark draw hours hand
810     LINE ox,oy TO ox+(xharm*(SIN((hrs+(mns/60))*2*PI/12))),oy+(yharm*(COS((hrs+(mns/60))*2*PI/12)))
820     REMark draw minutes hand
830     LINE ox,oy TO ox+(xmarm*(SIN(mns*2*PI/60))),oy+(ymarm*(COS(mns*2*PI/60)))
840     REMark draw seconds hand
850     LINE ox,oy TO ox+(xsarm*(SIN(scs*2*PI/60))),oy+(ysarm*(COS(scs*2*PI/60)))
860     REMark PRINT t$
870     REPeat loop2
880       IF DATE <> time : EXIT loop2
890     END REPeat loop2
900     REMark erase hands
910     LINE ox,oy TO ox+(xharm*(SIN((hrs+(mns/60))*2*PI/12))),oy+(yharm*(COS((hrs+(mns/60))*2*PI/12)))
920     LINE ox,oy TO ox+(xmarm*(SIN(mns*2*PI/60))),oy+(ymarm*(COS(mns*2*PI/60)))
930     LINE ox,oy TO ox+(xsarm*(SIN(scs*2*PI/60))),oy+(ysarm*(COS(scs*2*PI/60)))
940     OVER 0
950   END REPeat loop
960 END REPeat program
970 STOP
980 :
990 DEFine PROCedure CLOCK_FACE
1000   PAPER paper_col : CLS : OVER 1
1010   LET clock_scale = 256
1020   SCALE 346,0,0
1030   REMark this means 346 units vertically, 512 across?
1040   LET xradius = RND(50 TO 150)
1050   LET yradius = RND(50 TO 100)
1060   LET oy = RND(yradius TO (346-yradius))
1070   LET ox = RND(xradius TO (512-xradius))
1080   :
1090   REMark chance of shadow left/under/right
1100   IF RND(1 TO 3) = 2 THEN
1110     direction = RND(1 TO 5) : INK 0 : FILL 1
1120     SELect ON direction
1130       =1:CIRCLE ox-(ox/10),oy,150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1140       =2:CIRCLE ox,oy-(oy/10),150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1150       =3:CIRCLE ox+(ox/10),oy,150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1160       =4:CIRCLE ox+(ox/10),oy-(oy/10),150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1170       =5:CIRCLE ox-(ox/10),oy-(oy/10),150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1180     END SELect
1190     FILL 0
1200   END IF
1210   :
1220   REMark outline outside numbers
1230   INK marks_col : FILL 1
1240   CIRCLE ox,oy,150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1250   FILL 0
1260   :
1270   REMark outline in black
1280   INK 0
1290   CIRCLE ox,oy,150*yradius/100,(150*xradius/100)/(150*yradius/100),0
1300   :
1310   REMark inner circle, including numbers
1320   INK face_col : FILL 1 : REMark avoids problems
1330   CIRCLE ox,oy,136*yradius/100,(136*xradius/100)/(136*yradius/100),0
1340   FILL 0
1350   :
1360   REMark black outline for this circle
1370   INK 0
1380   CIRCLE ox,oy,136*yradius/100,(136*xradius/100)/(136*yradius/100),0
1390   :
1400   REMark small circle around origin of arms
1410   INK marks_col
1420   CIRCLE ox,oy,10*yradius/100,(10*xradius/100)/(20*yradius/100),0
1430   :
1440   REMark print clock digits
1450   time = 1
1460   FOR angle = 2*PI/12 TO 2*PI STEP 2*PI/12
1470     CURSOR ox+((120*xradius/100)*SIN(angle)),oy+((120*yradius/100)*COS(angle)),-6-(8*(time>9)),-5
1480     PRINT time
1490     time = time + 1
1500   END FOR angle
1510   dot = 0 : INK marks_col
1520   FOR angle =  2*PI/60 TO 2*PI STEP 2*PI/60
1530     IF (dot MOD 5) = 4 THEN
1540       REMark five minute marker
1550       LINE ox+((106*xradius/100)*SIN(angle)),oy+((106*yradius/100)*COS(angle)) TO ox+((xradius)*SIN(angle)),oy+((yradius)*COS(angle))
1560       dot = 0
1570     ELSE
1580       REMark dot only
1590       POINT ox+((106*xradius/100)*SIN(angle)),oy+((106*yradius/100)*COS(angle))
1600       dot = dot + 1
1610     END IF
1620   END FOR angle
1630   :
1640   IF RND(1 TO 2) = 2 THEN
1650     REMark draw the PRESS A KEY message
1660     AT 0,0 : CSIZE 2,1 : INK marks_col
1670     CURSOR ox,oy,-30,-30 : PRINT 'PRESS'
1680     CURSOR ox,oy,-30,10 : PRINT 'A KEY'
1690     OVER 0 : INK hand_col : CSIZE 2,0
1700   END IF
1710 END DEFine CLOCK_FACE
